=== modified file 'bzrlib/errors.py'
--- bzrlib/errors.py	2011-05-26 08:05:45 +0000
+++ bzrlib/errors.py	2011-05-26 20:22:44 +0000
@@ -1715,10 +1715,16 @@
 
 class InvalidHttpResponse(TransportError):
 
-    _fmt = "Invalid http response for %(path)s: %(msg)s"
+    _fmt = "Invalid http response for %(path)s: %(msg)s%(orig_error)s"
 
     def __init__(self, path, msg, orig_error=None):
         self.path = path
+        if orig_error is None:
+            orig_error = ''
+        else:
+            # This is reached for obscure and unusual errors so we want to
+            # preserve as much info as possible to ease debug.
+            orig_error = ': %r' % (orig_error,)
         TransportError.__init__(self, msg, orig_error=orig_error)
 
 

=== modified file 'doc/en/release-notes/bzr-2.4.txt'
--- doc/en/release-notes/bzr-2.4.txt	2011-05-26 16:28:31 +0000
+++ doc/en/release-notes/bzr-2.4.txt	2011-05-26 20:24:20 +0000
@@ -32,6 +32,9 @@
 .. Fixes for situations where bzr would previously crash or give incorrect
    or undesirable results.
 
+* Reports the original error when an InvalidHttpResponse exception is
+  encountered to facilitate debug. (Vincent Ladeuil, #788530)
+
 Documentation
 *************
 

